'********************************  FUNCTIONS  ********************************
Sub Setdmxch(byval Channel As Word , Byval Startvalue As Byte , Byval Endvalue As Byte , Byval Fadetime As Word)
   Local Steps As Integer
   Local Ftime As Long
   Local Ftemp As Single

   If Channel < 1 Or Channel > Lastchan Then Exit Sub

   If Fadetime = 0 Then
      ' Schalten
      Newdmxfield(channel) = Endvalue
      Dmxfield(channel) = Endvalue
   Else
      ' Dimmen
      Dmxfield(channel) = Startvalue
      ' Minimale Fadezeit ist 1ms/Schritt, also 255ms fr 0..255
      Steps = Startvalue - Endvalue
      Steps = Abs(steps)                                    ' Schritte, die es zu dimmen gilt
      Ftime = Fadetime * 1000
      Ftemp = Ftime / Steps
      Dmxsteps(channel) = Int(ftemp)                        ' Wartezyklen bis nchster Inkrementierungsschritt
      Newdmxfield(channel) = Endvalue
   End If
End Sub

Sub Stepupch(byval Channel As Word)
'   0..64..127..191..255
   Select Case Newdmxfield(channel)
      Case 0 To 63 : Call Setdmxch(channel , Dmxfield(channel) , 64 , Globalfadeintime)
      Case 64 To 126 : Call Setdmxch(channel , Dmxfield(channel) , 127 , Globalfadeintime)
      Case 127 To 190 : Call Setdmxch(channel , Dmxfield(channel) , 191 , Globalfadeintime)
      Case 191 To 255 : Call Setdmxch(channel , Dmxfield(channel) , 255 , Globalfadeintime)
   End Select
End Sub

Sub Stepdownch(byval Channel As Word)
'   0..64..127..191..255
   Select Case Newdmxfield(channel)
      Case 192 To 255 : Call Setdmxch(channel , Dmxfield(channel) , 191 , Globalfadeintime)
      Case 128 To 191 : Call Setdmxch(channel , Dmxfield(channel) , 127 , Globalfadeintime)
      Case 65 To 127 : Call Setdmxch(channel , Dmxfield(channel) , 64 , Globalfadeintime)
      Case 1 To 64 : Call Setdmxch(channel , Dmxfield(channel) , 0 , Globalfadeintime)
   End Select
End Sub

Sub Readtemp
   Local Ar1 As Byte
   Local Ar2 As Byte

   Disable Interrupts                                       ' Interrupts stren bei der 1Wire-Kommunikation

   1wreset
   1wwrite &HCC
   1wwrite &H44
   Waitms 100
   1wreset
   1wwrite &HCC
   1wwrite &HBE
   Ar1 = 1wread()
   Ar2 = 1wread()

   Enable Interrupts                                        ' Interrupts wieder aktivieren
   Udr = 0                                                  ' DMX512-Sender wieder starten

   Temperatur = Ar1
   If Ar2 > 0 Then Temperatur = 0 Else Shift Temperatur , Right
   Halb = Ar1 And 1
   If Halb = 1 Then Halb = 5 Else Halb = 0
End Sub

Sub Heatctrl
 Temp_diff = Temperatur - Temp_soll

 If Temp_online > 0 Then
  ' Heizungsystem ist eingeschaltet
  If Temp_diff < 0 Then
   'Raum zu Kalt -> Heizung muss eingeschaltet werden
   If Temp_online = 5 Then
    ' Automatische Heizkrperanzahl
    If Temp_diff < -3 Then
     'nur 1 Heizkrper
     Call Setdmxch(21 , 255 , 255 , 0)
     Call Setdmxch(22 , 0 , 0 , 0)
     Call Setdmxch(23 , 0 , 0 , 0)
     Call Setdmxch(24 , 0 , 0 , 0)
    Elseif Temp_diff < -6 Then
     '2 Heizkrper
     Call Setdmxch(21 , 255 , 255 , 0)
     Call Setdmxch(22 , 255 , 255 , 0)
     Call Setdmxch(23 , 0 , 0 , 0)
     Call Setdmxch(24 , 0 , 0 , 0)
    Elseif Temp_diff < -9 Then
     '3 Heizkrper
     Call Setdmxch(21 , 255 , 255 , 0)
     Call Setdmxch(22 , 255 , 255 , 0)
     Call Setdmxch(23 , 255 , 255 , 0)
     Call Setdmxch(24 , 0 , 0 , 0)
    Elseif Temp_diff < -12 Then
     'Alle Heizkrper
     Call Setdmxch(21 , 255 , 255 , 0)
     Call Setdmxch(22 , 255 , 255 , 0)
     Call Setdmxch(23 , 255 , 255 , 0)
     Call Setdmxch(24 , 255 , 255 , 0)
    End If
   Else
    'Manuelle Heizkrperanzahl
    If Temp_online > 0 Then
     Call Setdmxch(21 , 255 , 255 , 0)
    Else
     Call Setdmxch(21 , 0 , 0 , 0)
    End If

    If Temp_online > 1 Then
     Call Setdmxch(22 , 255 , 255 , 0)
    Else
     Call Setdmxch(22 , 0 , 0 , 0)
    End If

    If Temp_online > 2 Then
     Call Setdmxch(23 , 255 , 255 , 0)
    Else
     Call Setdmxch(23 , 0 , 0 , 0)
    End If

    If Temp_online > 3 Then
     Call Setdmxch(24 , 255 , 255 , 0)
    Else
     Call Setdmxch(24 , 0 , 0 , 0)
    End If
   End If
  Else
   ' Raum hat Solltemperatur erreicht -> Heizungen ausschalten
   Call Setdmxch(21 , 0 , 0 , 0)
   Call Setdmxch(22 , 0 , 0 , 0)
   Call Setdmxch(23 , 0 , 0 , 0)
   Call Setdmxch(24 , 0 , 0 , 0)
  End If
 Else
  ' Heizungssystem ausgeschaltet
  Call Setdmxch(21 , 0 , 0 , 0)
  Call Setdmxch(22 , 0 , 0 , 0)
  Call Setdmxch(23 , 0 , 0 , 0)
  Call Setdmxch(24 , 0 , 0 , 0)
 End If
End Sub

Sub Readtouch
   Local Col As Byte
   Local Row As Byte

   Config Pina.0 = Output                                   ' Makes port F.0 output
   Config Pina.2 = Output                                   ' Makes port F.0 output
   Set Porta.0                                              ' Sets port F.0 High
   Reset Porta.2                                            ' Sets port F.2 Low
   Ddra.1 = 0                                               ' Sets port F.1 as input
   Ddra.3 = 0                                               ' Sets port F.1 as input because we need it now as ad input
   Waitus 500                                               ' Wait until the port is stable
   Touchx = Getadc(3)                                       ' Read the ad value for the y

   Config Pina.1 = Output                                   ' Makes port F.1 output
   Config Pina.3 = Output                                   ' Makes port F.3 output
   Reset Porta.1                                            ' Sets port F.1 Low
   Set Porta.3                                              ' Sets port F.3 High
   Ddra.0 = 0                                               ' Sets port F.0 as input
   Ddra.2 = 0                                               ' Sets port F.2 as input because we need it now as ad input
   Waitus 500                                               ' Wait until the port is stable
   Touchy = Getadc(2)                                       ' Read the ad value for the x
   Touchy = 1024 - Touchy                                   ' Invert the reading

   ' Touchscreen in Raster aufteilen
   Select Case Touchx
      Case 150 To 300 : Col = 1
      Case 350 To 500 : Col = 2
      Case 550 To 700 : Col = 3
      Case 750 To 900 : Col = 4
      Case Else Col = 0
   End Select

   Select Case Touchy
      Case 200 To 350 : Row = 1
      Case 351 To 500 : Row = 2
      Case 501 To 650 : Row = 3
      Case 651 To 800 : Row = 4
      Case 801 To 1024 : Row = 5
      Case Else Row = 0
   End Select

   If Col > 0 And Row > 0 Then Call Menuaction(col , Row)
End Sub

Sub Proceedrc5
   Select Case Rc5address
      Case 0:
         Select Case Rc5command
'            Case 1 To 8 : Currentchannel = Rc5command
'            Case 1 : Call Stepupch(currentchannel)
'            Case 2 : Call Stepdownch(currentchannel)
            Case 1 : Call Runscene(1)
            Case 2 : Call Runscene(2)
            Case 3 : Call Runscene(3)
            Case 4 : Call Runscene(4)
            Case 5 : Call Runscene(5)
            Case 6 : Call Runscene(6)
            Case 7 : Call Runscene(7)
            Case 8 : Call Runscene(8)
         End Select
   End Select
End Sub

Sub Savescene(byval Scene As Byte)
' Ive got problems with successive writing into eeprom. So Ive done it step by step. It has to be optimized later...

   Select Case Scene
      Case 1:
'         Writeeeprom Scenename , Eepscenename1
         Writeeeprom Dmxfield(1) , 8
         Writeeeprom Dmxfield(2) , 9
         Writeeeprom Dmxfield(3) , 10
         Writeeeprom Dmxfield(4) , 11
         Writeeeprom Dmxfield(5) , 12
         Writeeeprom Dmxfield(6) , 13
         Writeeeprom Dmxfield(7) , 14
         Writeeeprom Dmxfield(8) , 15
         Writeeeprom Dmxfield(9) , 16
         Writeeeprom Dmxfield(10) , 17
         Writeeeprom Dmxfield(11) , 18
         Writeeeprom Dmxfield(12) , 19
         Writeeeprom Dmxfield(13) , 20
         Writeeeprom Dmxfield(14) , 21
         Writeeeprom Dmxfield(15) , 22
         Writeeeprom Dmxfield(16) , 23
         Writeeeprom Dmxfield(17) , 24
         Writeeeprom Dmxfield(18) , 25
         Writeeeprom Dmxfield(19) , 26
         Writeeeprom Dmxfield(20) , 27
         Writeeeprom Dmxfield(21) , 28
         Writeeeprom Dmxfield(22) , 29
         Writeeeprom Dmxfield(23) , 30
         Writeeeprom Dmxfield(24) , 31
      Case 2:
'         Writeeeprom Scenename , Eepscenename2
         Writeeeprom Dmxfield(1) , 32
         Writeeeprom Dmxfield(2) , 33
         Writeeeprom Dmxfield(3) , 34
         Writeeeprom Dmxfield(4) , 35
         Writeeeprom Dmxfield(5) , 36
         Writeeeprom Dmxfield(6) , 37
         Writeeeprom Dmxfield(7) , 38
         Writeeeprom Dmxfield(8) , 39
         Writeeeprom Dmxfield(9) , 40
         Writeeeprom Dmxfield(10) , 41
         Writeeeprom Dmxfield(11) , 42
         Writeeeprom Dmxfield(12) , 43
         Writeeeprom Dmxfield(13) , 44
         Writeeeprom Dmxfield(14) , 45
         Writeeeprom Dmxfield(15) , 46
         Writeeeprom Dmxfield(16) , 47
         Writeeeprom Dmxfield(17) , 48
         Writeeeprom Dmxfield(18) , 49
         Writeeeprom Dmxfield(19) , 50
         Writeeeprom Dmxfield(20) , 51
         Writeeeprom Dmxfield(21) , 52
         Writeeeprom Dmxfield(22) , 53
         Writeeeprom Dmxfield(23) , 54
         Writeeeprom Dmxfield(24) , 55
      Case 3:
'         Writeeeprom Scenename , Eepscenename3
         Writeeeprom Dmxfield(1) , 56
         Writeeeprom Dmxfield(2) , 57
         Writeeeprom Dmxfield(3) , 58
         Writeeeprom Dmxfield(4) , 59
         Writeeeprom Dmxfield(5) , 60
         Writeeeprom Dmxfield(6) , 61
         Writeeeprom Dmxfield(7) , 62
         Writeeeprom Dmxfield(8) , 63
         Writeeeprom Dmxfield(9) , 64
         Writeeeprom Dmxfield(10) , 65
         Writeeeprom Dmxfield(11) , 66
         Writeeeprom Dmxfield(12) , 67
         Writeeeprom Dmxfield(13) , 68
         Writeeeprom Dmxfield(14) , 69
         Writeeeprom Dmxfield(15) , 70
         Writeeeprom Dmxfield(16) , 71
         Writeeeprom Dmxfield(17) , 72
         Writeeeprom Dmxfield(18) , 73
         Writeeeprom Dmxfield(19) , 74
         Writeeeprom Dmxfield(20) , 75
         Writeeeprom Dmxfield(21) , 76
         Writeeeprom Dmxfield(22) , 77
         Writeeeprom Dmxfield(23) , 78
         Writeeeprom Dmxfield(24) , 79
      Case 4:
'         Writeeeprom Scenename , Eepscenename4
         Writeeeprom Dmxfield(1) , 80
         Writeeeprom Dmxfield(2) , 81
         Writeeeprom Dmxfield(3) , 82
         Writeeeprom Dmxfield(4) , 83
         Writeeeprom Dmxfield(5) , 84
         Writeeeprom Dmxfield(6) , 85
         Writeeeprom Dmxfield(7) , 86
         Writeeeprom Dmxfield(8) , 87
         Writeeeprom Dmxfield(9) , 88
         Writeeeprom Dmxfield(10) , 89
         Writeeeprom Dmxfield(11) , 90
         Writeeeprom Dmxfield(12) , 91
         Writeeeprom Dmxfield(13) , 92
         Writeeeprom Dmxfield(14) , 93
         Writeeeprom Dmxfield(15) , 94
         Writeeeprom Dmxfield(16) , 95
         Writeeeprom Dmxfield(17) , 96
         Writeeeprom Dmxfield(18) , 97
         Writeeeprom Dmxfield(19) , 98
         Writeeeprom Dmxfield(20) , 99
         Writeeeprom Dmxfield(21) , 100
         Writeeeprom Dmxfield(22) , 101
         Writeeeprom Dmxfield(23) , 102
         Writeeeprom Dmxfield(24) , 103
      Case 5:
'         Writeeeprom Scenename , Eepscenename5
         Writeeeprom Dmxfield(1) , 104
         Writeeeprom Dmxfield(2) , 105
         Writeeeprom Dmxfield(3) , 106
         Writeeeprom Dmxfield(4) , 107
         Writeeeprom Dmxfield(5) , 108
         Writeeeprom Dmxfield(6) , 109
         Writeeeprom Dmxfield(7) , 110
         Writeeeprom Dmxfield(8) , 111
         Writeeeprom Dmxfield(9) , 112
         Writeeeprom Dmxfield(10) , 113
         Writeeeprom Dmxfield(11) , 114
         Writeeeprom Dmxfield(12) , 115
         Writeeeprom Dmxfield(13) , 116
         Writeeeprom Dmxfield(14) , 117
         Writeeeprom Dmxfield(15) , 118
         Writeeeprom Dmxfield(16) , 119
         Writeeeprom Dmxfield(17) , 120
         Writeeeprom Dmxfield(18) , 121
         Writeeeprom Dmxfield(19) , 122
         Writeeeprom Dmxfield(20) , 123
         Writeeeprom Dmxfield(21) , 124
         Writeeeprom Dmxfield(22) , 125
         Writeeeprom Dmxfield(23) , 126
         Writeeeprom Dmxfield(24) , 127
      Case 6:
'         Writeeeprom Scenename , Eepscenename6
         Writeeeprom Dmxfield(1) , 128
         Writeeeprom Dmxfield(2) , 129
         Writeeeprom Dmxfield(3) , 130
         Writeeeprom Dmxfield(4) , 131
         Writeeeprom Dmxfield(5) , 132
         Writeeeprom Dmxfield(6) , 133
         Writeeeprom Dmxfield(7) , 134
         Writeeeprom Dmxfield(8) , 135
         Writeeeprom Dmxfield(9) , 136
         Writeeeprom Dmxfield(10) , 137
         Writeeeprom Dmxfield(11) , 138
         Writeeeprom Dmxfield(12) , 139
         Writeeeprom Dmxfield(13) , 140
         Writeeeprom Dmxfield(14) , 141
         Writeeeprom Dmxfield(15) , 142
         Writeeeprom Dmxfield(16) , 143
         Writeeeprom Dmxfield(17) , 144
         Writeeeprom Dmxfield(18) , 145
         Writeeeprom Dmxfield(19) , 146
         Writeeeprom Dmxfield(20) , 147
         Writeeeprom Dmxfield(21) , 148
         Writeeeprom Dmxfield(22) , 149
         Writeeeprom Dmxfield(23) , 150
         Writeeeprom Dmxfield(24) , 151
      Case 7:
'         Writeeeprom Scenename , Eepscenename7
         Writeeeprom Dmxfield(1) , 152
         Writeeeprom Dmxfield(2) , 153
         Writeeeprom Dmxfield(3) , 154
         Writeeeprom Dmxfield(4) , 155
         Writeeeprom Dmxfield(5) , 156
         Writeeeprom Dmxfield(6) , 157
         Writeeeprom Dmxfield(7) , 158
         Writeeeprom Dmxfield(8) , 159
         Writeeeprom Dmxfield(9) , 160
         Writeeeprom Dmxfield(10) , 161
         Writeeeprom Dmxfield(11) , 162
         Writeeeprom Dmxfield(12) , 163
         Writeeeprom Dmxfield(13) , 164
         Writeeeprom Dmxfield(14) , 165
         Writeeeprom Dmxfield(15) , 166
         Writeeeprom Dmxfield(16) , 167
         Writeeeprom Dmxfield(17) , 168
         Writeeeprom Dmxfield(18) , 169
         Writeeeprom Dmxfield(19) , 170
         Writeeeprom Dmxfield(20) , 171
         Writeeeprom Dmxfield(21) , 172
         Writeeeprom Dmxfield(22) , 173
         Writeeeprom Dmxfield(23) , 174
         Writeeeprom Dmxfield(24) , 175
      Case 8:
'         Writeeeprom Scenename , Eepscenename8
         Writeeeprom Dmxfield(1) , 176
         Writeeeprom Dmxfield(2) , 177
         Writeeeprom Dmxfield(3) , 178
         Writeeeprom Dmxfield(4) , 179
         Writeeeprom Dmxfield(5) , 180
         Writeeeprom Dmxfield(6) , 181
         Writeeeprom Dmxfield(7) , 182
         Writeeeprom Dmxfield(8) , 183
         Writeeeprom Dmxfield(9) , 184
         Writeeeprom Dmxfield(10) , 185
         Writeeeprom Dmxfield(11) , 186
         Writeeeprom Dmxfield(12) , 187
         Writeeeprom Dmxfield(13) , 188
         Writeeeprom Dmxfield(14) , 189
         Writeeeprom Dmxfield(15) , 190
         Writeeeprom Dmxfield(16) , 191
         Writeeeprom Dmxfield(17) , 192
         Writeeeprom Dmxfield(18) , 193
         Writeeeprom Dmxfield(19) , 194
         Writeeeprom Dmxfield(20) , 195
         Writeeeprom Dmxfield(21) , 196
         Writeeeprom Dmxfield(22) , 197
         Writeeeprom Dmxfield(23) , 198
         Writeeeprom Dmxfield(24) , 199
   End Select
End Sub

Sub Runscene(byval Scene As Byte)
' Ive got problems with successive reading out of eeprom. So Ive done it step by step. It has to be optimized later...

   Select Case Scene
      Case 1:
'         Readeeprom Scenename , Eepscenename1
         Readeeprom Scenevalue(1) , 8
         Readeeprom Scenevalue(2) , 9
         Readeeprom Scenevalue(3) , 10
         Readeeprom Scenevalue(4) , 11
         Readeeprom Scenevalue(5) , 12
         Readeeprom Scenevalue(6) , 13
         Readeeprom Scenevalue(7) , 14
         Readeeprom Scenevalue(8) , 15
         Readeeprom Scenevalue(9) , 16
         Readeeprom Scenevalue(10) , 17
         Readeeprom Scenevalue(11) , 18
         Readeeprom Scenevalue(12) , 19
         Readeeprom Scenevalue(13) , 20
         Readeeprom Scenevalue(14) , 21
         Readeeprom Scenevalue(15) , 22
         Readeeprom Scenevalue(16) , 23
         Readeeprom Scenevalue(17) , 24
         Readeeprom Scenevalue(18) , 25
         Readeeprom Scenevalue(19) , 26
         Readeeprom Scenevalue(20) , 27
         Readeeprom Scenevalue(21) , 28
         Readeeprom Scenevalue(22) , 29
         Readeeprom Scenevalue(23) , 30
         Readeeprom Scenevalue(24) , 31
      Case 2:
'         Readeeprom Scenename , Eepscenename2
         Readeeprom Scenevalue(1) , 32
         Readeeprom Scenevalue(2) , 33
         Readeeprom Scenevalue(3) , 34
         Readeeprom Scenevalue(4) , 35
         Readeeprom Scenevalue(5) , 36
         Readeeprom Scenevalue(6) , 37
         Readeeprom Scenevalue(7) , 38
         Readeeprom Scenevalue(8) , 39
         Readeeprom Scenevalue(9) , 40
         Readeeprom Scenevalue(10) , 41
         Readeeprom Scenevalue(11) , 42
         Readeeprom Scenevalue(12) , 43
         Readeeprom Scenevalue(13) , 44
         Readeeprom Scenevalue(14) , 45
         Readeeprom Scenevalue(15) , 46
         Readeeprom Scenevalue(16) , 47
         Readeeprom Scenevalue(17) , 48
         Readeeprom Scenevalue(18) , 49
         Readeeprom Scenevalue(19) , 50
         Readeeprom Scenevalue(20) , 51
         Readeeprom Scenevalue(21) , 52
         Readeeprom Scenevalue(22) , 53
         Readeeprom Scenevalue(23) , 54
         Readeeprom Scenevalue(24) , 55
      Case 3:
'         Readeeprom Scenename , Eepscenename3
         Readeeprom Scenevalue(1) , 56
         Readeeprom Scenevalue(2) , 57
         Readeeprom Scenevalue(3) , 58
         Readeeprom Scenevalue(4) , 59
         Readeeprom Scenevalue(5) , 60
         Readeeprom Scenevalue(6) , 61
         Readeeprom Scenevalue(7) , 62
         Readeeprom Scenevalue(8) , 63
         Readeeprom Scenevalue(9) , 64
         Readeeprom Scenevalue(10) , 65
         Readeeprom Scenevalue(11) , 66
         Readeeprom Scenevalue(12) , 67
         Readeeprom Scenevalue(13) , 68
         Readeeprom Scenevalue(14) , 69
         Readeeprom Scenevalue(15) , 70
         Readeeprom Scenevalue(16) , 71
         Readeeprom Scenevalue(17) , 72
         Readeeprom Scenevalue(18) , 73
         Readeeprom Scenevalue(19) , 74
         Readeeprom Scenevalue(20) , 75
         Readeeprom Scenevalue(21) , 76
         Readeeprom Scenevalue(22) , 77
         Readeeprom Scenevalue(23) , 78
         Readeeprom Scenevalue(24) , 79
      Case 4:
'         Readeeprom Scenename , Eepscenename4
         Readeeprom Scenevalue(1) , 80
         Readeeprom Scenevalue(2) , 81
         Readeeprom Scenevalue(3) , 82
         Readeeprom Scenevalue(4) , 83
         Readeeprom Scenevalue(5) , 84
         Readeeprom Scenevalue(6) , 85
         Readeeprom Scenevalue(7) , 86
         Readeeprom Scenevalue(8) , 87
         Readeeprom Scenevalue(9) , 88
         Readeeprom Scenevalue(10) , 89
         Readeeprom Scenevalue(11) , 90
         Readeeprom Scenevalue(12) , 91
         Readeeprom Scenevalue(13) , 92
         Readeeprom Scenevalue(14) , 93
         Readeeprom Scenevalue(15) , 94
         Readeeprom Scenevalue(16) , 95
         Readeeprom Scenevalue(17) , 96
         Readeeprom Scenevalue(18) , 97
         Readeeprom Scenevalue(19) , 98
         Readeeprom Scenevalue(20) , 99
         Readeeprom Scenevalue(21) , 100
         Readeeprom Scenevalue(22) , 101
         Readeeprom Scenevalue(23) , 102
         Readeeprom Scenevalue(24) , 103
      Case 5:
'         Readeeprom Scenename , Eepscenename5
         Readeeprom Scenevalue(1) , 104
         Readeeprom Scenevalue(2) , 105
         Readeeprom Scenevalue(3) , 106
         Readeeprom Scenevalue(4) , 107
         Readeeprom Scenevalue(5) , 108
         Readeeprom Scenevalue(6) , 109
         Readeeprom Scenevalue(7) , 110
         Readeeprom Scenevalue(8) , 111
         Readeeprom Scenevalue(9) , 112
         Readeeprom Scenevalue(10) , 113
         Readeeprom Scenevalue(11) , 114
         Readeeprom Scenevalue(12) , 115
         Readeeprom Scenevalue(13) , 116
         Readeeprom Scenevalue(14) , 117
         Readeeprom Scenevalue(15) , 118
         Readeeprom Scenevalue(16) , 119
         Readeeprom Scenevalue(17) , 120
         Readeeprom Scenevalue(18) , 121
         Readeeprom Scenevalue(19) , 122
         Readeeprom Scenevalue(20) , 123
         Readeeprom Scenevalue(21) , 124
         Readeeprom Scenevalue(22) , 125
         Readeeprom Scenevalue(23) , 126
         Readeeprom Scenevalue(24) , 127
      Case 6:
'         Readeeprom Scenename , Eepscenename6
         Readeeprom Scenevalue(1) , 128
         Readeeprom Scenevalue(2) , 129
         Readeeprom Scenevalue(3) , 130
         Readeeprom Scenevalue(4) , 131
         Readeeprom Scenevalue(5) , 132
         Readeeprom Scenevalue(6) , 133
         Readeeprom Scenevalue(7) , 134
         Readeeprom Scenevalue(8) , 135
         Readeeprom Scenevalue(9) , 136
         Readeeprom Scenevalue(10) , 137
         Readeeprom Scenevalue(11) , 138
         Readeeprom Scenevalue(12) , 139
         Readeeprom Scenevalue(13) , 140
         Readeeprom Scenevalue(14) , 141
         Readeeprom Scenevalue(15) , 142
         Readeeprom Scenevalue(16) , 143
         Readeeprom Scenevalue(17) , 144
         Readeeprom Scenevalue(18) , 145
         Readeeprom Scenevalue(19) , 146
         Readeeprom Scenevalue(20) , 147
         Readeeprom Scenevalue(21) , 148
         Readeeprom Scenevalue(22) , 149
         Readeeprom Scenevalue(23) , 150
         Readeeprom Scenevalue(24) , 151
      Case 7:
'         Readeeprom Scenename , Eepscenename7
         Readeeprom Scenevalue(1) , 152
         Readeeprom Scenevalue(2) , 153
         Readeeprom Scenevalue(3) , 154
         Readeeprom Scenevalue(4) , 155
         Readeeprom Scenevalue(5) , 156
         Readeeprom Scenevalue(6) , 157
         Readeeprom Scenevalue(7) , 158
         Readeeprom Scenevalue(8) , 159
         Readeeprom Scenevalue(9) , 160
         Readeeprom Scenevalue(10) , 161
         Readeeprom Scenevalue(11) , 162
         Readeeprom Scenevalue(12) , 163
         Readeeprom Scenevalue(13) , 164
         Readeeprom Scenevalue(14) , 165
         Readeeprom Scenevalue(15) , 166
         Readeeprom Scenevalue(16) , 167
         Readeeprom Scenevalue(17) , 168
         Readeeprom Scenevalue(18) , 169
         Readeeprom Scenevalue(19) , 170
         Readeeprom Scenevalue(20) , 171
         Readeeprom Scenevalue(21) , 172
         Readeeprom Scenevalue(22) , 173
         Readeeprom Scenevalue(23) , 174
         Readeeprom Scenevalue(24) , 175
      Case 8:
'         Readeeprom Scenename , Eepscenename8
         Readeeprom Scenevalue(1) , 176
         Readeeprom Scenevalue(2) , 177
         Readeeprom Scenevalue(3) , 178
         Readeeprom Scenevalue(4) , 179
         Readeeprom Scenevalue(5) , 180
         Readeeprom Scenevalue(6) , 181
         Readeeprom Scenevalue(7) , 182
         Readeeprom Scenevalue(8) , 183
         Readeeprom Scenevalue(9) , 184
         Readeeprom Scenevalue(10) , 185
         Readeeprom Scenevalue(11) , 186
         Readeeprom Scenevalue(12) , 187
         Readeeprom Scenevalue(13) , 188
         Readeeprom Scenevalue(14) , 189
         Readeeprom Scenevalue(15) , 190
         Readeeprom Scenevalue(16) , 191
         Readeeprom Scenevalue(17) , 192
         Readeeprom Scenevalue(18) , 193
         Readeeprom Scenevalue(19) , 194
         Readeeprom Scenevalue(20) , 195
         Readeeprom Scenevalue(21) , 196
         Readeeprom Scenevalue(22) , 197
         Readeeprom Scenevalue(23) , 198
         Readeeprom Scenevalue(24) , 199
   End Select

   For Iw = 1 To Lastchan
      Call Setdmxch(iw , Dmxfield(iw) , Scenevalue(iw) , Globalfadeintime)
   Next Iw
End Sub

Sub Refreshscreen
   #if Rc5debug = 1
      ' RC5-Codes anzeigen
      If Rc5address < 255 Then
         Locate 15 , 1
         Lcd "Letzter RC5-Code: "
         Select Case Rc5address
            Case 0 : Lcd "Hauppauge"
            Case 15 : Lcd "DVD"
            Case 16 : Lcd "General"
            Case 17 : Lcd "Tuner"
            Case 18 : Lcd "Tape"
            Case 20 : Lcd "CD"
            Case 21 : Lcd "Phono"
            Case 22 : Lcd "DSR/AUX"
            Case 23 : Lcd "DCC"
         End Select
         Lcd " (" ; Rc5address ; ", " ; Rc5command ; ")       "
      End If
   #endif

   Select Case Currentmenu
      Case 0:
         'Hauptmen
         ' Zeit aktualisieren
         Locate 16 , 1
         Lcd Time$ ; " " ; Date$
         Locate 16 , 23
         Lcd Temperatur ; "." ; Halb ; "C "

         Locate 15 , 1
         Lcd "Aktueller Kanal: " ; Currentchannel ; " (" ; Newdmxfield(currentchannel) ; ")    "
         Locate 16 , 35
         Lcd Brightness ; "  "
      Case 1:
         'Licht-Men
      Case 3:
         #if Analogclock = 1
            Clocksec = _sec
            Call Drawclock

            Locate 15 , 1
            Lcd Time$
            Locate 16 , 1
            Lcd Date$
            Locate 16 , 36
            Lcd Temperatur ; "." ; Halb ; "C "
         #endif
      Case 7:
            Locate 15 , 1
            Lcd Time$
            Locate 16 , 1
            Lcd Date$
   End Select
End Sub

Sub Menuaction(byval Col As Byte , Byval Row As Byte)
   Local Percent As Single
   Local Ipercent As Byte

   If Backlight = 0 Then
      Set Backlight                                         ' Hintergrundbeleuchtung einschalten
      Exit Sub
   End If

   If Row = 5 Then                                          ' immer zum Ausgangsmen springen
      Currentmenu = 0
      Cls Text
      Showpic 0 , 0 , Mainmenu
   Else
      Select Case Currentmenu
         Case 0:
            ' Funktion im Hauptmen gewhlt
            If Col = 1 And Row < 3 Then
               ' Licht-Men
               Currentmenu = 1
               Currentfunction = 1                          ' Kanal 1 vorwhlen
               Cls Text
               Showpic 0 , 0 , Submenu
               Locate 2 , 4
               Lcd "Manuelles Licht"

               Locate 4 , 4
               Lcd "Kanal: " ; Currentfunction
               Percent = Dmxfield(currentfunction) / 2.55
               Ipercent = Round(percent)
               Locate 5 , 4
               Lcd "Aktuell: " ; Ipercent ; "%"
            Elseif Col = 2 And Row < 3 Then
               ' Szenen-Men
               Currentmenu = 2
               Cls Text
               Showpic 0 , 0 , Szenenmenu

               Readeeprom Scenename , Eepscenename1
               Locate 6 , 3 : Lcd Scenename
               Readeeprom Scenename , Eepscenename2
               Locate 6 , 13 : Lcd Scenename
               Readeeprom Scenename , Eepscenename3
               Locate 6 , 23 : Lcd Scenename
               Readeeprom Scenename , Eepscenename4
               Locate 6 , 33 : Lcd Scenename
               Readeeprom Scenename , Eepscenename5
               Locate 13 , 3 : Lcd Scenename
               Readeeprom Scenename , Eepscenename6
               Locate 13 , 13 : Lcd Scenename
               Readeeprom Scenename , Eepscenename7
               Locate 13 , 23 : Lcd Scenename
               Readeeprom Scenename , Eepscenename8
               Locate 13 , 33 : Lcd Scenename
            Elseif Col = 3 And Row < 3 Then
               'Analoguhr
               Currentmenu = 3
               #if Analogclock = 1
                  Clocksec = Time$
                  Cls
                  Call Drawclock
               #endif
            Elseif Col = 4 And Row < 3 Then
               ' Setup-Men
               Currentmenu = 4
               Cls Text
               Showpic 0 , 0 , Submenu
               Locate 2 , 4
               Lcd "Einstellungen"

               #if Network = 1
                  Locate 4 , 4
                  Lcd "IP-Adresse:"
                  Locate 5 , 4
                  Lcd Myip(1) ; "." ; Myip(2) ; "." ; Myip(3) ; "." ; Myip(4)
               #endif

               Locate 8 , 4
               Lcd "Uhrzeit:"
               Locate 9 , 4
               Lcd Time$

               Locate 12 , 4
               Lcd "Datum:"
               Locate 13 , 4
               Lcd Date$
            Elseif Col = 1 And Row > 2 Then
               ' Heizungs-Men
               Currentmenu = 5
               Currentfunction = 0
               Cls Text
               Showpic 0 , 0 , Submenu
               Locate 2 , 4
               Lcd "Heizungssteuerung"

               Locate 6 , 4
               Lcd "Istwert: " ; Temperatur ; "." ; Halb ; "C"

               Locate 7 , 4
               Lcd "Sollwert: " ; Temp_soll ; "C"

               Temp_diff = Temperatur - Temp_soll
               Locate 8 , 4
               Lcd "Differenz: " ; Temp_diff ; "C"
			   
               Locate 10 , 4
               If Temp_online = 0 Then
                   Lcd "Heizung: AUS"
               Elseif Temp_online > 0 Then
                   Lcd "Heizung: " ; Temp_online ; "x"
               Elseif Temp_online = 5 Then
				   Lcd "Heizung: AUTO" ; Temp_online
               End If
			   
			   Locate 13, 4
			   Lcd "<SPEICHERN>"
            Elseif Col = 2 And Row > 2 Then
               ' Szenen-Speichern-Men
               Currentmenu = 6
               Cls Text
               Showpic 0 , 0 , Szenenmenu

               Readeeprom Scenename , Eepscenename1
               Locate 6 , 3 : Lcd Scenename
               Readeeprom Scenename , Eepscenename2
               Locate 6 , 13 : Lcd Scenename
               Readeeprom Scenename , Eepscenename3
               Locate 6 , 23 : Lcd Scenename
               Readeeprom Scenename , Eepscenename4
               Locate 6 , 33 : Lcd Scenename
               Readeeprom Scenename , Eepscenename5
               Locate 13 , 3 : Lcd Scenename
               Readeeprom Scenename , Eepscenename6
               Locate 13 , 13 : Lcd Scenename
               Readeeprom Scenename , Eepscenename7
               Locate 13 , 23 : Lcd Scenename
               Readeeprom Scenename , Eepscenename8
               Locate 13 , 33 : Lcd Scenename
            Elseif Col = 3 And Row > 2 Then
               ' Zeit und Datum einstellen
               Currentmenu = 7
               Cls Text
               Showpic 0 , 0 , Szenenmenu

               Locate 6 , 3 : Lcd " +Std "
               Locate 6 , 13 : Lcd " +Min "
               Locate 6 , 23 : Lcd " +Tag "
               Locate 6 , 33 : Lcd "+Monat"
               Locate 13 , 3 : Lcd " -Std "
               Locate 13 , 13 : Lcd " -Min "
               Locate 13 , 23 : Lcd " -Tag "
               Locate 13 , 33 : Lcd "-Monat"
            Elseif Col = 4 And Row > 2 Then
               ' Info-Screen
               Currentmenu = 8
               Cls Text
               Showpic 0 , 0 , Picstartup
               Locate 1 , 1
               Lcd "AtriumUnum (RoomControl v5.0 Build 0025)"
               Locate 2 , 1
               Lcd "Dipl.-Ing. M.Sc. Chris Noeding"

               Locate 4 , 1
               Lcd "www.pcdimmer.de"

               #if Network = 1
                  Locate 6 , 1
                  Lcd "IP-Adresse:"
                  Locate 7 , 1
                  Lcd Myip(1) ; "." ; Myip(2) ; "." ; Myip(3) ; "." ; Myip(4)

                  Locate 9 , 1
                  Lcd "MAC-Adresse:"
                  Locate 10 , 1
                  Lcd Hex(mymac(1)) ; "-" ; Hex(mymac(2)) ; "-" ; Hex(mymac(3)) ; "-" ; Hex(mymac(4)) ; "-" ; Hex(mymac(5)) ; "-" ; Hex(mymac(6))
               #endif
            End If
         Case 1:
            ' Licht-Men-Funktion gewhlt
            If Col = 3 And Row = 1 Then
               '+
               If Dmxfield(currentfunction) < 255 Then
                  I = Dmxfield(currentfunction) + 1
                  Call Setdmxch(currentfunction , I , I , 0)
               End If
            Elseif Col = 3 And Row = 2 Then
               '-
               If Dmxfield(currentfunction) > 0 Then
                  I = Dmxfield(currentfunction) - 1
                  Call Setdmxch(currentfunction , I , I , 0)
               End If
            Elseif Col = 3 And Row = 3 Then
               '>
               Call Stepupch(currentfunction)
            Elseif Col = 3 And Row = 4 Then
               '<
               Call Stepdownch(currentfunction)
            Elseif Col = 4 And Row < 3 Then
               '^
               If Currentfunction < Lastchan Then
                  Incr Currentfunction
               Else
                  Currentfunction = 1
               End If
            Elseif Col = 4 And Row > 2 Then
               '\/
               If Currentfunction > 1 Then
                  Decr Currentfunction
               Else
                  Currentfunction = Lastchan
               End If
            End If

            Percent = Newdmxfield(currentfunction) / 2.55
            Ipercent = Round(percent)
            Locate 4 , 11
            Lcd Currentfunction ; "  "
            Locate 5 , 13
            Lcd Ipercent ; "%  "
         Case 2:
            ' Szenenmen
            If Col = 1 And Row < 3 Then
               Call Runscene(1)
            Elseif Col = 2 And Row < 3 Then
               Call Runscene(2)
            Elseif Col = 3 And Row < 3 Then
               Call Runscene(3)
            Elseif Col = 4 And Row < 3 Then
               Call Runscene(4)
            Elseif Col = 1 And Row > 2 Then
               Call Runscene(5)
            Elseif Col = 2 And Row > 2 Then
               Call Runscene(6)
            Elseif Col = 3 And Row > 2 Then
               Call Runscene(7)
            Elseif Col = 4 And Row > 2 Then
               Call Runscene(8)
            End If
         Case 3:
   ' Analoguhr
   ' bei jeder Taste zurck zum Hauptmen springen
   Currentmenu = 0
   Cls Text
   Showpic 0 , 0 , Mainmenu
         Case 4:
            ' Einstellungen
            #if Network = 1
               If Col = 1 And Row = 2 Then
                  Call Send_dhcp_discover                   'DHCP request
               End If
            #endif
    Case 5:
            'Heizungsmen
            If Col = 3 And Row = 1 Then                     '+
               If Temp_soll < 30 Then Incr Temp_soll
            Elseif Col = 3 And Row = 2 Then                 '-
               If Temp_soll > 0 Then Decr Temp_soll
            Elseif Col = 3 And Row = 3 Then                 '>
               If Temp_online < 5 Then Incr Temp_online
            Elseif Col = 3 And Row = 4 Then                 '<
               If Temp_online > 0 Then Decr Temp_online
            Elseif Col = 4 And Row < 3 Then                 '^
            Elseif Col = 4 And Row > 2 Then                 '\/
			Elseif Col = 1 And Row = 4 Then	                'Werte speichern
				Writeeeprom Temp_soll , 6
				Writeeeprom Temp_online , 7
            End If

            Locate 7 , 4
            Lcd "Sollwert: " ; Temp_soll ; "C  "

            Temp_diff = Temperatur - Temp_soll
            Locate 8 , 4
            Lcd "Differenz: " ; Temp_diff ; "C  "

            Locate 10 , 4
            If Temp_online = 0 Then
               Lcd "Heizung: AUS"
            Elseif Temp_online > 0 Then
               Lcd "Heizung: " ; Temp_online ; "x  "
            Elseif Temp_online = 5 Then
               Lcd "Heizung: AUTO"
            End If
         Case 6:
            ' Szenenspeichernmen
            If Col = 1 And Row < 3 Then
               Call Savescene(1)
            Elseif Col = 2 And Row < 3 Then
               Call Savescene(2)
            Elseif Col = 3 And Row < 3 Then
               Call Savescene(3)
            Elseif Col = 4 And Row < 3 Then
               Call Savescene(4)
            Elseif Col = 1 And Row > 2 Then
               Call Savescene(5)
            Elseif Col = 2 And Row > 2 Then
               Call Savescene(6)
            Elseif Col = 3 And Row > 2 Then
               Call Savescene(7)
            Elseif Col = 4 And Row > 2 Then
               Call Savescene(8)
            End If
     Case 7:
            ' Uhrzeit und Datum einstellen
            If Col = 1 And Row < 3 Then
               _hour = _hour + 1                            'Stunden
            Elseif Col = 2 And Row < 3 Then
               _min = _min + 1                              'Minuten
            Elseif Col = 3 And Row < 3 Then
               _day = _day + 1                              'Tage
            Elseif Col = 4 And Row < 3 Then
               _month = _month + 1                          'Monate
            Elseif Col = 1 And Row > 2 Then
               _hour = _hour - 1                            'Stunden
            Elseif Col = 2 And Row > 2 Then
               _min = _min - 1                              'Minuten
            Elseif Col = 3 And Row > 2 Then
               _day = _day - 1                              'Tage
            Elseif Col = 4 And Row > 2 Then
               _month = _month - 1                          'Monate
            End If
      Case 8:
         ' bei jeder Taste zurck zum Hauptmen springen
         Currentmenu = 0
         Cls Text
         Showpic 0 , 0 , Mainmenu
      End Select
   End If
End Sub

#if Analogclock = 1
Sub Drawclock
   ' Kreise
   Circle(centrex , Centrey) , Bigradius , 255
   Circle(centrex , Centrey) , Radius , 255

   ' Stunden eintragen
   For K = 0 To 360 Step 30
    Angle_rad = Angle - K
    Angle_rad = Angle_rad * Pirad
    Sinangle = Sin(angle_rad) : Cosangle = Cos(angle_rad)
    W = Radius * Cosangle
    Startx = Centrex + W
    W = Radius * Sinangle
    Starty = Centrey - W
    W = Bigradius * Cosangle
    Endx = Centrex + W
    W = Bigradius * Sinangle
    Endy = Centrey - W
    Startx = Round(startx) : Starty = Round(starty)
    Clockx = Int(startx) : Clocky = Int(starty)
    Endx = Round(endx) : Endy = Round(endy)
    Ax = Int(endx) : Ay = Int(endy)
    Line(clockx , Clocky) -(ax , Ay) , 255                  'sleppers
   Next
    K = 0

   'lschen
   Call Drawsecond(0 , Clocksec)
   Call Drawminute(0 , Clockmin)
   Call Drawhour(0 , Clockhour)

   'zeichnen
   Call Drawsecond(255 , Clocksec)
   Call Drawminute(255 , Clockmin)
   Call Drawhour(255 , Clockhour)
End Sub

Sub Drawsecond(byval Color As Byte , Byval Value As Byte)
   ' Sekundenzeiger

   If Color = 0 Then                                        ' Vorherigen Zeiger lschen
      W = Value - 1
   Else
      W = Value
   End If

   W = W * 6
   Angle_rad = Angle - W
   Angle_rad = Angle_rad * Pirad
   Sinangle = Sin(angle_rad) : Cosangle = Cos(angle_rad)
   W = Seconderadius * Cosangle
   Xseconde = Centrex + W
   W = Seconderadius * Sinangle
   Yseconde = Centrey - W
   Xseconde = Round(xseconde)
   Yseconde = Round(yseconde)
   Clockx = Int(xseconde)
   Clocky = Int(yseconde)
   Line(centrex , Centrey) -(clockx , Clocky) , Color
End Sub

Sub Drawminute(byval Color As Byte , Byval Value As Byte)
   ' Minutenzeiger

   If Color = 0 Then                                        ' Vorherigen Zeiger lschen
      W = Value - 1
   Else
      W = Value
   End If

   W = W * 6
   Angle_rad = Angle - W
   Angle_rad = Angle_rad * Pirad
   Sinangle = Sin(angle_rad) : Cosangle = Cos(angle_rad)
   W = Minuteradius * Cosangle
   Xseconde = Centrex + W
   W = Minuteradius * Sinangle
   Yseconde = Centrey - W
   Xseconde = Round(xseconde)
   Yseconde = Round(yseconde)
   Clockx = Int(xseconde)
   Clocky = Int(yseconde)
   Line(centrex , Centrey) -(clockx , Clocky) , Color

   ' Etwas dicker zeichnen
   If Color = 0 Then                                        ' Vorherigen Zeiger lschen
      W = Value - 1
   Else
      W = Value
   End If

   W = W * 6
   W = W + 1
   Angle_rad = Angle - W
   Angle_rad = Angle_rad * Pirad
   Sinangle = Sin(angle_rad) : Cosangle = Cos(angle_rad)
   W = Minuteradius * Cosangle
   Xseconde = Centrex + W
   W = Minuteradius * Sinangle
   Yseconde = Centrey - W
   Xseconde = Round(xseconde)
   Yseconde = Round(yseconde)
   Clockx = Int(xseconde)
   Clocky = Int(yseconde)
   Line(centrex , Centrey) -(clockx , Clocky) , Color

   If Color = 0 Then                                        ' Vorherigen Zeiger lschen
      W = Value - 1
   Else
      W = Value
   End If

   W = W * 6
   W = W - 1
   Angle_rad = Angle - W
   Angle_rad = Angle_rad * Pirad
   Sinangle = Sin(angle_rad) : Cosangle = Cos(angle_rad)
   W = Minuteradius * Cosangle
   Xseconde = Centrex + W
   W = Minuteradius * Sinangle
   Yseconde = Centrey - W
   Xseconde = Round(xseconde)
   Yseconde = Round(yseconde)
   Clockx = Int(xseconde)
   Clocky = Int(yseconde)
   Line(centrex , Centrey) -(clockx , Clocky) , Color
End Sub

Sub Drawhour(byval Color As Byte , Byval Value As Byte)
   ' Stundenzeiger

   If Color = 0 Then                                        ' Vorherigen Zeiger lschen
      W = Value - 1
   Else
      W = Value
   End If

   W = W * 30
   Angle_rad = Angle - W
   Angle_rad = Angle_rad * Pirad
   Sinangle = Sin(angle_rad) : Cosangle = Cos(angle_rad)
   W = Hourradius * Cosangle
   Xseconde = Centrex + W
   W = Hourradius * Sinangle
   Yseconde = Centrey - W
   Xseconde = Round(xseconde)
   Yseconde = Round(yseconde)
   Clockx = Int(xseconde)
   Clocky = Int(yseconde)
   Line(centrex , Centrey) -(clockx , Clocky) , Color

   ' Etwas dicker zeichnen
   If Color = 0 Then                                        ' Vorherigen Zeiger lschen
      W = Value - 1
   Else
      W = Value
   End If

   W = W * 30
   W = W + 1
   Angle_rad = Angle - W
   Angle_rad = Angle_rad * Pirad
   Sinangle = Sin(angle_rad) : Cosangle = Cos(angle_rad)
   W = Hourradius * Cosangle
   Xseconde = Centrex + W
   W = Hourradius * Sinangle
   Yseconde = Centrey - W
   Xseconde = Round(xseconde)
   Yseconde = Round(yseconde)
   Clockx = Int(xseconde)
   Clocky = Int(yseconde)
   Line(centrex , Centrey) -(clockx , Clocky) , Color

   If Color = 0 Then                                        ' Vorherigen Zeiger lschen
      W = Value - 1
   Else
      W = Value
   End If

   W = W * 30
   W = W - 1
   Angle_rad = Angle - W
   Angle_rad = Angle_rad * Pirad
   Sinangle = Sin(angle_rad) : Cosangle = Cos(angle_rad)
   W = Hourradius * Cosangle
   Xseconde = Centrex + W
   W = Hourradius * Sinangle
   Yseconde = Centrey - W
   Xseconde = Round(xseconde)
   Yseconde = Round(yseconde)
   Clockx = Int(xseconde)
   Clocky = Int(yseconde)
   Line(centrex , Centrey) -(clockx , Clocky) , Color
End Sub
#endif